%if 0%{?fedora} || 0%{?rhel} == 6
%global with_devel 1
%global with_bundled 0
%global with_debug 0
# cannot find package "github.com/fsouza/go-dockerclient/vendor/github.com/docker/docker/pkg/archive"
%global with_check 0
%global with_unit_test 1
%else
%global with_devel 0
%global with_bundled 0
%global with_debug 0
%global with_check 0
%global with_unit_test 0
%endif

%if 0%{?with_debug}
%global _dwz_low_mem_die_limit 0
%else
%global debug_package   %{nil}
%endif

%define copying() \
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 7 \
%license %{*} \
%else \
%doc %{*} \
%endif

%global provider        github
%global provider_tld    com
%global project         fsouza
%global repo            go-dockerclient
# https://github.com/fsouza/go-dockerclient
%global provider_prefix %{provider}.%{provider_tld}/%{project}/%{repo}
%global import_path     %{provider_prefix}
%global commit          f95d189acbfcb8628482decdb662d30bc74913e8
%global shortcommit     %(c=%{commit}; echo ${c:0:7})

Name:           golang-%{provider}-%{project}-%{repo}
Version:        0.2.1
Release:        9.git%{shortcommit}%{?dist}
Summary:        Client for the Docker remote API
License:        BSD
URL:            https://%{provider_prefix}
Source0:        https://%{provider_prefix}/archive/%{commit}/%{repo}-%{shortcommit}.tar.gz

# If go_arches not defined fall through to implicit golang archs
%if 0%{?go_arches:1}
ExclusiveArch:  %{go_arches}
%else
ExclusiveArch:   %{ix86} x86_64 %{arm}
%endif
# If gccgo_arches does not fit or is not defined fall through to golang
%ifarch 0%{?gccgo_arches}
BuildRequires:   gcc-go >= %{gccgo_min_vers}
%else
BuildRequires:   golang
%endif

%description
%{summary}

%if 0%{?with_devel}
%package devel
Summary:       %{summary}
BuildArch:     noarch

%if 0%{?with_check}
%endif


Provides:      golang(%{import_path}) = %{version}-%{release}
Provides:      golang(%{import_path}/testing) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/Sirupsen/logrus) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/docker/docker/pkg/archive) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/docker/docker/pkg/fileutils) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/docker/docker/pkg/ioutils) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/docker/docker/pkg/pools) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/docker/docker/pkg/promise) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/docker/docker/pkg/stdcopy) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/docker/docker/pkg/system) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/docker/docker/pkg/units) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/gorilla/context) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/gorilla/mux) = %{version}-%{release}

%description devel
%{summary}

This package contains library source intended for
building other packages which use import path with
%{import_path} prefix.
%endif

%if 0%{?with_unit_test}
%package unit-test
Summary:         Unit tests for %{name} package
# If go_arches not defined fall through to implicit golang archs
%if 0%{?go_arches:1}
ExclusiveArch:  %{go_arches}
%else
ExclusiveArch:   %{ix86} x86_64 %{arm}
%endif
# If gccgo_arches does not fit or is not defined fall through to golang
%ifarch 0%{?gccgo_arches}
BuildRequires:   gcc-go >= %{gccgo_min_vers}
%else
BuildRequires:   golang
%endif

%if 0%{?with_check}
#Here comes all BuildRequires: PACKAGE the unit tests
#in %%check section need for running
%endif

# test subpackage tests code from devel subpackage
Requires:        %{name}-devel = %{version}-%{release}

%description unit-test
%{summary}

This package contains unit tests for project
providing packages with %{import_path} prefix.
%endif

%prep
%setup -q -n %{repo}-%{commit}

%build

%install
# source codes for building projects
%if 0%{?with_devel}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
# find all *.go but no *_test.go files and generate devel.file-list
for file in $(find . -iname "*.go" \! -iname "*_test.go" | grep -v "./vendor") ; do
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> devel.file-list
done
%endif

# testing files for this project
%if 0%{?with_unit_test}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/testing/data
cp -rpav testing/data %{buildroot}/%{gopath}/src/%{import_path}/testing/.
echo "%%{gopath}/src/%%{import_path}/testing/data" >> unit-test.file-list
# find all *_test.go files and generate unit-test.file-list
for file in $(find . -iname "*_test.go" | grep -v "./vendor"); do
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> unit-test.file-list
done
%endif

%check
%if 0%{?with_check} && 0%{?with_unit_test} && 0%{?with_devel}
%ifarch 0%{?gccgo_arches}
function gotest { %{gcc_go_test} "$@"; }
%else
%if 0%{?golang_test:1}
function gotest { %{golang_test} "$@"; }
%else
function gotest { go test "$@"; }
%endif
%endif

export GOPATH=%{buildroot}/%{gopath}:%{gopath}
gotest %{import_path}
gotest %{import_path}/testing
%endif

%if 0%{?with_devel}
%files devel -f devel.file-list
%copying LICENSE DOCKER-LICENSE
%doc AUTHORS README.markdown
%dir %{gopath}/src/%{provider}.%{provider_tld}/%{project}
%dir %{gopath}/src/%{import_path}
%endif

%if 0%{?with_unit_test}
%files unit-test -f unit-test.file-list
%copying LICENSE DOCKER-LICENSE
%doc AUTHORS README.markdown
%endif

%changelog
* Fri Jul 31 2015 jchaloup <jchaloup@redhat.com> - 0.2.1-9.gitf95d189
- Update spec file to spec-2.0
  related: #1215656

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.2.1-8.gitf95d189
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Wed Jun 10 2015 jchaloup <jchaloup@redhat.com> - 0.2.1-7.gitf95d189
- Add missing Provides
  related: #1215656

* Tue Jun 02 2015 jchaloup <jchaloup@redhat.com> - 0.2.1-6.gitf95d189
- Bump to upstream f95d189acbfcb8628482decdb662d30bc74913e8
  related: #1215656

* Mon Apr 27 2015 jchaloup <jchaloup@redhat.com> - 0.2.1-5.git0dfe1f1
- Bump to upstream 0dfe1f16045e9e460430ee10ec1dea8d86c9bd9f
  resolves: #1215656

* Wed Jan 28 2015 jchaloup <jchaloup@redhat.com> - 0.2.1-4.git0758f40
- Bump to upstream 0758f407f25a8df60c540b0ec758905192687e14
  related: #1085840

* Wed Dec 24 2014 jchaloup <jchaloup@redhat.com> - 0.2.1-3.git15d2c6e
- Bump to b52383442df766febf51f9f858ee311f69a2f264
  related: #1085840

* Thu Oct 16 2014 lsm5@riseup.net - 0.2.1-2.git15d2c6e
- update to latest upstream commit

* Mon Sep 29 2014 Lokesh Mandvekar <lsm5@fedoraproject.org> - 0.2.1-1.git0236a64
- update to upstream commit 0236a64c6c4bd563ec277ba00e370cc753e1677c
- don't own dirs owned by golang, don't redefine gopath
- preserve timestamps of copied files

* Tue Jul 22 2014 Colin Walters <walters@redhat.com>
- Update to newer version for Kubernetes work

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0-0.2.gitd639515
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Thu Apr 03 2014 Lokesh Mandvekar <lsm5@redhat.com> 0-0.1.git
- Initial package
